#include "Deture.h"
#include <string.h>

CDeture::CDeture(){
	size = 0;
	org_function = NULL;
	real_function = NULL;
}

CDeture::~CDeture(){
	unhook();
	delete (char*)org_function;
}
int CDeture::find_offset(void* function, int min_offset){
	_DecodeResult res;
	_DecodedInst decodedInstructions[100];
	_DecodeType dt = Decode32Bits;
	_OffsetType offset = 0;
	unsigned int decodedInstructionsCount = 0;
	int InstrSize = 0;
	
	res = distorm_decode(offset, (const unsigned char*)function, 64, dt, decodedInstructions, sizeof(decodedInstructions)/sizeof(_DecodedInst), &decodedInstructionsCount);
	if (res == DECRES_INPUTERR) {
		return -1;
	}
	for (unsigned int i = 0; i < decodedInstructionsCount; ++i) {
		if(InstrSize>=min_offset)
			break;
		InstrSize += decodedInstructions[i].size;
	}
	if(InstrSize<min_offset)
		return -1;
	else
		return InstrSize;
}

static const char* __jmp_temp = "\x68\x00\x00\x00\x00\xC3";
#define __jmp_temp_size 6

bool CDeture::hook_function(void* original, void* fake){
	if(org_function){
		delete (char*)org_function;
		org_function = NULL;
	}
	
	int size_needed = find_offset(original, __jmp_temp_size);
	if(size_needed < 0)
		return false;
	real_function = original;
	char make_jmp[__jmp_temp_size];
	memcpy(make_jmp, __jmp_temp, __jmp_temp_size);
	unsigned int fake_offset = (unsigned int)fake;
	memcpy(make_jmp+1, (void*)&fake_offset, sizeof(fake_offset));

	org_function = (void*)new char[size_needed+__jmp_temp_size];

	g_MemMng.ReadMemmory(original, org_function, size_needed);

	memcpy((char*)org_function+size_needed, __jmp_temp,__jmp_temp_size);
	unsigned int original_offset_br = (unsigned int)original + size_needed;
	memcpy((char*)org_function+size_needed+1, (void*)&original_offset_br, sizeof(original_offset_br));

	size = size_needed;

	g_MemMng.WriteMemmory(original, make_jmp, __jmp_temp_size);
	g_MemMng.unprotect(org_function, size_needed+__jmp_temp_size);
	return true;
}

bool CDeture::unhook(){
	bool bRc;
	if(org_function == NULL || real_function == NULL){
		bRc = false;
		goto exit;
	}
	bRc = g_MemMng.WriteMemmory(real_function, org_function, __jmp_temp_size);
exit:
	return bRc;
}

void* CDeture::original_ptr(){
	return org_function;
}
